// $Id: teestream.C,v 1.1 2001/07/05 10:30:27 dvermeir Exp $
#include "teestream.h"

namespace Demo {

TeeStream::TeeStream(): ostream(0), tee_() {
// Set fdstreambuf of ostream to filterstreambuf linked to tee_
// filter.
rdbuf(new FilterStreambuf<Tee>(tee_));
}

TeeStream&
TeeStream::add(ostream& os) { 
tee_.add(os);
return *this;
}

TeeStream::Tee::~Tee() { 
sync(); 
}

int
TeeStream::Tee::put(int c) { 
bool ok(c!=EOF); // Will be true iff all went well.
if (ok) // Write character on each stream in streams_.
  for (list<ostream*>::const_iterator i=streams_.begin(); 
      i!=streams_.end(); ++i) {
    if (!(**i).put(c))
      ok = false;
    }
return (ok?c:EOF);
}

int
TeeStream::Tee::sync() { 
bool ok(true);
// Sync each of the streams in streams_ via their streambuf.
for (list<ostream*>::const_iterator i=streams_.begin(); 
    i!=streams_.end(); ++i) {
  ok = ok && ((**i).rdbuf()->sync() == 0);
  }
return (ok?0:EOF);
}

}
