#ifndef DEMO_TEESTREAM_H
#define DEMO_TEESTREAM_H
// $Id: teestream.h,v 1.1 2001/07/05 10:30:27 dvermeir Exp $

#include <iostream>
#include <list>

#include "filterstreambuf.h"

// This file defines a class TeeStream, named after the unix ``tee''
// command. A TeeStream is an ostream specialization where anything
// written to a TeeStream object is actually written to a number of
// underlying ostream objects.

namespace Demo {

class TeeStream: public std::ostream {
public:
  TeeStream();
  // Add an ostream of a TeeStream. 
  TeeStream& add(ostream& os);
private:

  // The TeeStream::Tee class will be used as a filter for the underlying
  // FilterStreambuf object. See the requirements for filters in
  // filterstreambuf.h.
  class Tee {
  public:
    Tee() {}
    ~Tee();
    int put(int c);
    int get() { return EOF; } // Input is not supported.
    int sync();
    void close() {}
    // Add a stream to the collection.
    void add(ostream& os) { streams_.push_back(&os); }
  private:
    std::list<ostream*>	streams_;
  };

  Tee	tee_;
};

}
#endif
