// $Id: tteestream.C,v 1.1 2001/07/05 10:30:28 dvermeir Exp $

#include <fstream> // For ofstream.
#include <stdexcept> // For runtime_error.

#include "teestream.h"

// This program copies the standard input (cin) to a number of files,
// one for each argument. E.g.
// 
// cat data | tteestream file1 file2 file3 
// 
// will copy the contents of data to each of the files file1, file2,
// and file3.

int
main(int argc,char* argv[]) {
try {
  Demo::TeeStream	teestream;
  
  for (int i=1; (i<argc); ++i) {
    std::ofstream* ofsptr(new ofstream(argv[i]));
    if (!*ofsptr) 
      throw runtime_error(string("Cannot create \"")+argv[i]+"\"");
    teestream.add(*ofsptr);
    }
  
  // Copies cin to teestream, see book p. 230.
  teestream << cin.rdbuf();
  
  return 0;
  }
catch (exception& e) {
  cerr << e.what() << endl;
  return 1;
  }
}
